AOZ Studio Beta - Bug #959

Boolean function results are not working on If statement.
12/03/2022 06:34 PM - Brian Flanagan

Status: New Start date: 12/03/2022
Priority: High Due date:

Assignee: AQOZ Developers % Done: 0%
Category: Estimated time: 0:00 hour
Target version: none

Affected version: 1.0.0 (B16) u27

Description

Example:

Function CantMoveDown
End Function (True)

// This code fails
Procedure MoveDown
Print CantMoveDown
If CantMoveDown
Say "cannot"
End If
If Not CantMoveDown
Say "can"
End If
End Procedure

/*
// This code works
Procedure MoveDown
Print CantMoveDown
If (CantMoveDown=True)
Say "cannot"
End If
If Not (CantMoveDown=True)
Say "can"
End If
End Procedure

*/

Print "Waiting..."
Do
Wait Key
MoveDown
If Upper$ (Inkey$)="Q" Then Exit
Loop
End

If you comment the first procedure version, and uncomment the second, you'll find that if you explicitly check the value
of true or false, it works, but apparently the If statement does not evauluate the value of a simple boolean result properly.

This was tested using the newest source from .git as of 11/27.

History

#1 - 12/03/2022 06:36 PM - Brian Flanagan

Note also that Print evaluates the result properly. If is the problem.

#2 - 12/03/2022 06:44 PM - Brian Flanagan
- Priority changed from Normal to High
#3 - 01/19/2023 06:27 AM - Francois Lionet
Fixed! Bad bug in the transpiler.
